#ifndef EM_H
#define EM_H

#include <gsl/gsl_matrix.h>

#include "mixture.h"

typedef struct em {
  unsigned int maxiter;
  double       treshold;
  double       error;
  unsigned int iter;
  double       ll;
  int          verbose;

  char*        mask;
  mixture*     mixture;
  double*      weights;
  param**      components;
  gsl_matrix*  posterior;
  int          has_changed;

  family*      ef;
  unsigned int k;
  double*      data;
  unsigned int n;
  unsigned int dim;
  double       old_error;
} em;

em* em_create(family*      ef,
              unsigned int k,
              double*      data,
              unsigned int n,
              unsigned int dim
              );
void em_initialize_from_clustering(em* em, double* weights, unsigned int* affectation);
void em_step(em *em);
mixture* em_run(em *em);
void em_destroy(em *em);

#endif
